
<!DOCTYPE html>
<html>
  <head>
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>React calculator</title>
    <!--ICON-->
     <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.1/css/all.css" integrity="sha384-50oBUHEmvpQ+1lW4y57PTFmhCaXp0ML5d60M1M7uH2+nqUivzIebhndOJK28anvf" crossorigin="anonymous">
    <!--G Font-->
    <link href="https://fonts.googleapis.com/css?family=Graduate&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="style.css">
    <!--React-->
    <script crossorigin src="https://unpkg.com/react@16/umd/react.production.min.js"></script>
    <!--ReactDom-->
<script crossorigin src="https://unpkg.com/react-dom@16/umd/react-dom.production.min.js"></script>
  </head>
  <body>
        <a href="https://linkedin.com/in/fsbalbuena/">FSBalbuena</a>  
    <main id="main"></main>
    <script src="https://unpkg.com/babel-standalone@6/babel.min.js"></script>
    <script type="text/babel" >
    function calculate(str,i=0){
    //array of operations
    let op=[{fn:(a,b)=>a+b,symbol:"+"},
    {fn:(a,b)=>a-b,symbol:"-"},
    {fn:(a,b)=>a*b,symbol:"x"},
    {fn:(a,b)=>a/b,symbol:"/"}]
    if(!isNaN(str)){
        //if string is already a number return it
        return parseFloat(str)
    }else{
        //take away all space
        str=str.replace(/\s/g,"").replace(/\D+/g,str=>str.slice(-1))
        //spread de string by his current operator
        str=str.split(op[i].symbol)
        return str.length==1?calculate(str[0],i+1):str.reduce((a,b)=>op[i].fn(calculate(a,i+1),calculate(b,i+1)))
    }

}
//----------------------------------------------------------------
//---------COMPONENTS-------------------------------------------------------
const Button=({char,str,handleClick})=>(<span id={str} className="btn" onClick={handleClick}>{char}</span>)
const Display=({text})=>(<p id="display">{text?text:"0"}</p>)

//----------------------------------------------------------------
//---------CONTAINERS-------------------------------------------------------


//----------------------------------------------------------------
//---------EXECUTE-------------------------------------------------------
class OperationContainer extends React.Component{
    constructor(props){
        super(props)
        this.state={
            operations:[{char:"+",str:"add"},{char:"-",str:"subtract"},{char:"x",str:"multiply"},{char:"/",str:"divide"},]
        }
    }
    render(){
        const {handleClick}=this.props
        const {operations}=this.state
        return (<div id="operations">{operations.map(b=><Button str={b.str} char={b.char} handleClick={handleClick}/>)}</div>)
    }
}


class NumbersContainer extends React.Component{
    constructor(props){
        super(props)
        this.state={
            numbers:[{char:"1",str:"one"},{char:"2",str:"two"},{char:"3",str:"three"},{char:"4",str:"four"},{char:"5",str:"five"},
            {char:"6",str:"six"},{char:"7",str:"seven"},{char:"8",str:"eight"},{char:"9",str:"nine"}]
        }
    }
    render(){
        const {handleClick}=this.props
        const {numbers}=this.state
        return (<div id="numbers">{numbers.map(b=><Button str={b.str} char={b.char} handleClick={handleClick}/>)}</div>)
    }
}

class SpecialButtonsContainer extends React.Component{
    constructor(props){
        super(props)
        this.state={
            buttons:[{char:"0",str:"zero"},{char:".",str:"decimal"},{char:"CE",str:"clear"},]
        }
    }
    render(){
        const {handleClick}=this.props
        const {buttons}=this.state
        return (<div id="specialButtons">{buttons.map(b=><Button str={b.str} char={b.char} handleClick={handleClick}/>)}</div>)
    }
}


class EqualContainer extends React.Component{
    constructor(props){
        super(props)
        this.state={
            equal:{char:"=",str:"equals"},
        }
    }
    render(){
        const {handleClick}=this.props
        const {equal}=this.state
        return (<Button str={equal.str} char={equal.char} handleClick={handleClick}/>)
    }
}

class Main extends React.Component{
    constructor(props){
        super(props)
        this.state={
            text:""
        }
        this.handleSpecialButtons=this.handleSpecialButtons.bind(this)
        this.handleOperations=this.handleOperations.bind(this)
        this.handleEqual=this.handleEqual.bind(this)        
        this.handleNumbers=this.handleNumbers.bind(this)
    }
    handleSpecialButtons(e){
        let str=e.target.textContent
        let text=this.state.text
        let lastWord=text.split(" ").slice(-1)[0]
        let newText=text
        if(str=="CE"){
            newText=""
        }
        else if(str=="." && lastWord && lastWord.indexOf(str)==-1 ){
                newText+=str
        }
        else if(str=="0" && !(lastWord=="0")){
            newText+=str
        }
        this.setState({text:newText})
    }
    handleOperations(e){
        let str=e.target.textContent
        let text=this.state.text
        let newText=text
        if(["+","-","x","/"].indexOf(str)!=-1 && text.slice(-2)!="" ){
            newText+=` ${str} `
            this.setState({text:newText})
        }
    }
    handleNumbers(e){
        let str=e.target.textContent
        this.setState(state=>({text:state.text+str}))
    }
    handleEqual(){
        let operation=calculate(this.state.text)
        this.setState({text:operation+""})
    }
    render(){
        const text=this.state.text
        return (<div id="calculator">
                <Display text={text}/>
                <NumbersContainer handleClick={this.handleNumbers}/>
                <SpecialButtonsContainer handleClick={this.handleSpecialButtons}/>
                <OperationContainer handleClick={this.handleOperations}/>
                <EqualContainer handleClick={this.handleEqual}/>
                </div>)
    }
}

ReactDOM.render(<Main/>,document.getElementById("main"))
    </script>
</body>
</html>